﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace tx_mailmerge_includetext
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            mailMerge1.LoadTemplate("template.docx", TXTextControl.DocumentServer.FileFormat.WordprocessingML);
            mailMerge1.IncludeTextMerging += new TXTextControl.DocumentServer.MailMerge.IncludeTextMergingHandler(mailMerge1_IncludeTextMerging);
            mailMerge1.Merge(null, false);
            mailMerge1.SaveDocument("results.pdf", TXTextControl.StreamType.AdobePDF, new TXTextControl.SaveSettings());
        }

        void mailMerge1_IncludeTextMerging(object sender, TXTextControl.DocumentServer.MailMerge.IncludeTextMergingEventArgs e)
        {
            // create temporary ServerTextControl
            TXTextControl.ServerTextControl tempTX = new TXTextControl.ServerTextControl();
            tempTX.Create();

            switch (e.Filename)
            {
                case "\\field1":
                    tempTX.Text = "Field 1 inserted at " + DateTime.Now.ToString();
                    tempTX.Select(0, 7);
                    tempTX.Selection.Bold = true;
                    break;

                case "\\field2":
                    tempTX.Text = "Field 2 inserted at " + DateTime.Now.ToString();
                    tempTX.Select(0, 7);
                    tempTX.Selection.Italic = true;
                    break;
            }

            byte[] data;
            
            // save document in a byte[] array
            tempTX.Save(out data, TXTextControl.BinaryStreamType.InternalUnicodeFormat);
            tempTX.Dispose();

            // pass document back to the MailMerge component
            e.IncludeTextDocument = data;
        }
    }
}
